abuild 6.74 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25
#!/bin/sh

# script to build apk packages (light version og makepkg)
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

myver=0.2

# read config
MAKEAPK_CONF=${MAKEAPK_CONF:-/etc/abuild.conf}
[ -f "$MAKEAPK_CONF" ] && . "$MAKEAPK_CONF"

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
pkgdir=${pkgdir:-"$startdir/pkg"}
pkgrel=0

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}

26
default_cmds="checkdeps clean fetch checkmd5 unpack rootpkg"
Natanael Copa's avatar
Natanael Copa committed
27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58
all_cmds="checksum fetch unpack rootpkg build package cleancache clean srcpkg"

# functions
vecho() {
	local sub=
	[ -n "$INSUB" ] && sub="(sub)"
	[ -z "$quiet" ] && echo ">>> $pkgname:" "$@" $sub >&2
}

warning() {
	echo ">>> Warning:" "$@" >&2
}

die() {
	quiet=
	vecho "$@" >&2
	exit 1
}

# check if we have needed packages to build this thing
checkdeps() {
	local i
	local missing=
	for i in $makedepends; do
		apk_info -e $i || missing="$missing $i"
	done
	[ -z "$missing" ] && return 0
	warning "Missing makedepends: $missing"
	return 1
}

checkmd5() {
59 60 61 62
	if [ -z "$md5sums" ]; then
		die "Use 'abuild checksum >>$APKBUILD' to generate a checksum"
	fi
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
63 64 65 66 67
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
68 69 70 71
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
72
	mkdir -p "$SRCDEST"
73 74 75
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
76
	fi
77 78
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114
}

fetch() {
	local s
	mkdir -p "$srcdir"
	for s in $source; do 
		case "$s" in
			http://*|ftp://*)
				uri_fetch "$s" || return 1
				;;
		esac
		ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
	done
}

# unpack the sources
unpack() {
	local u
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
			*.tar.gz)
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
				tar -C "$srcdir" -jxf "$s" || return 1;;
		esac
	done
}

# cleanup source and package dir
clean() {
	rm -rf "$srcdir"
	rm -rf "$pkgdir"
	local i
	for i in $subpackages; do
115
		rm -rf "$pkgdir-$i"
Natanael Copa's avatar
Natanael Copa committed
116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135
	done
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
		case "$s" in
			http:/*|ftp:/*)
				rm -f "$SRCDIR/$(basename $s)";;
		esac
	done
}

cleanpkg() {
	local p=$pkgname-$pkgver
	[ $pkgrel -ne 0 ] && p="$p-r$pkgrel"
	rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz"
	local i
	for i in $subpackages; do
136
		INSUB=1 subpkgdir="$pkgdir-$i" $0 $i cleanpkg
Natanael Copa's avatar
Natanael Copa committed
137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155
	done
}

runpart() {
	local part=$1
	vecho "$part"
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

subpkg() {
	[ -z "$subpackages" ] && return 0
	local i
	cd "$startdir"
	for i in $subpackages; do
156
		INSUB=1 subpkgdir="$pkgdir-$i" $0 $i package || return 1
Natanael Copa's avatar
Natanael Copa committed
157 158 159 160
	done
}

package_apk() {
161
	local dir=${subpkgdir:-$pkgdir}
Natanael Copa's avatar
Natanael Copa committed
162 163 164
	local p="$pkgname-$pkgver"
	[ "$pkgrel" -ne 0 ] && p="$p-r$pkgrel"
	local pkg="$p.apk"
165
	local db="$dir/var/db/apk/$p"
Natanael Copa's avatar
Natanael Copa committed
166 167 168 169 170 171 172 173 174 175
	mkdir -p "$db"
	echo "$arch" > "$db/ARCH"
	echo "$pkgdesc" > "$db/DESC"
	echo "$license" > "$db/LICENSE"
	echo "$depends" > "$db/DEPEND"
	echo "$url" > "$db/WWW"
	local i
	for i in pre-install post-install pre-deinstall post-deinstall; do
		[ -f ../$i ] && cp ../$i "$db"/
	done
176
	( cd "$dir" && tar -zcf "$PKGDEST/$pkg" * )
Natanael Copa's avatar
Natanael Copa committed
177 178 179 180 181 182 183 184 185 186 187 188
}

package() {
	package_apk
}

# predefined subpackage doc
doc() {
	pkgname="$pkgname-doc"
	depends=""
	local i
	for i in doc man info html sgml; do
189 190 191
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
192 193
		fi
	done
194 195 196 197

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

198
	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
199 200 201 202 203 204 205 206
	return 0
}

# predefined subpackage mod
mod() {
	pkgname="$pkgname-mod"
	depends="$kernel"
	for i in firmware modules; do
207 208 209 210
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
			mv "$pkgdir/lib/$i" "$subdir/lib"
Natanael Copa's avatar
Natanael Copa committed
211 212 213 214 215 216
		fi
	done
}

# predefined subpackage dev
dev() {
217
	depends="$pkgname"
Natanael Copa's avatar
Natanael Copa committed
218
	pkgname="$pkgname-dev"
219
	for i in $(cd "$pkgdir" && find usr/lib -name '*.a' -o \
Natanael Copa's avatar
Natanael Copa committed
220 221
			-name '*.la' -o -name '*.o' 2>/dev/null) \
			usr/include usr/lib/pkgconfig usr/share/aclocal; do
222 223
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
224
			mkdir -p "$d"
225
			mv "$pkgdir/$i" "$d"
Natanael Copa's avatar
Natanael Copa committed
226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246
		fi
	done
}

# build and package in fakeroot
rootpkg() {
	fakeroot $0 build subpkg package
}

srcpkg() {
	local p="$pkgname-$pkgver"
	[ "$pkgrel" -ne 0 ] && p="$p-r$pkgrel"
	local prefix="${PWD##*/}"
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
	(cd .. && tar -zcf $PKGDEST/$p.src.tar.gz $files) 
}

247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262
# check if package is up to date
up2date() {
	local p="$pkgname-$pkgver"
	[ "$pkgrel" -ne 0 ] && p="$p-r$pkgrel"
	local pkg="$PKGDEST/$p.apk"
	local i s
	[ -f "$pkg" ] || return 1
	for i in $source APKBUILD; do
		local s="$SRCDEST/${i##*/}"	# $(basename $i)
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281
usage() {
	echo "$(basename $0) $myver"
	echo "usage: $0 [options] [cmd] ..."
	echo "Options:"
	echo " -h  Show this help"
	echo " -f  Force specified cmd, even if they are already done"
	echo " -q  Quiet"
	echo ""
	echo "Commands:"
	echo "  checksum   Generate checksum to be included in $APKBUILD"
	echo "  fetch      Fetch sources to \$SRCDEST and verify checksums"
	echo "  unpack     Unpack sources to \$srcdir"
	echo "  build      Compile and install package into \$pkgdir"
	echo "  package    Create package in \$PKGDEST"
	echo "  rootpkg    Run '$0 build package' as fakeroot"
	echo "  clean      Remove temp build and install dirs"
	echo "  cleanpkg   Remove already built binary and source package"
	echo "  cleancache Remove downloaded files from \$SRCDEST"
	echo "  srcpkg     Make a source package"
Natanael Copa's avatar
Natanael Copa committed
282
	echo "  up2date    Compare target and sources dates"
Natanael Copa's avatar
Natanael Copa committed
283 284 285 286 287 288 289 290 291
	echo ""
	exit 0
}

checksum() {
	local s files
	for s in $source; do
		files="$files ${s##*/}"
	done
292 293
	md5sums="$(cd "$SRCDEST" && md5sum $files)" || die "md5sum failed"
	echo "md5sums=\"$md5sums\""
Natanael Copa's avatar
Natanael Copa committed
294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319
}

APKBUILD="${APKBUILD:-./APKBUILD}"

while getopts "hfq" opt; do
	case $opt in
		'h') usage;;
		'f') force=1;;
		'q') quiet=1;;
	esac
done
shift $(( $OPTIND - 1 ))

# source the buildfile
[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
. "$APKBUILD"

# If we are handling a sub package then reset subpackages
[ -n "$INSUB" ] && subpackages=

trap 'die "Aborted by user"' INT

[ -n "$forceunpack" ] && rm -f "$srcdir"/.unpack


if [ -z "$1" ]; then
Natanael Copa's avatar
Natanael Copa committed
320
	if up2date && [ -z "$force" ]; then
321 322 323 324
		vecho "Package is up to date"
	else
		set $default_cmds
	fi
Natanael Copa's avatar
Natanael Copa committed
325 326 327 328 329 330 331
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done